#!/usr/bin/perl

#

# spiders.pl

#

# Matt Kruse

#

# Make graphs of when spiders have visited



use Graph;

use Time::Local;



$log = shift || "access_log";

$days = 365;



%MONTHS=(

'Jan','01','Feb','02','Mar','03','Apr','04','May','05','Jun','06',

'Jul','07','Aug','08','Sep','09','Oct','10','Nov','11','Dec','12');



sub ReadLog {

	$LOG=$_[0];

	print STDERR "Reading Log: $LOG\n";

	open (LOG,"$LOG");

	while (<LOG>) {

		unless

		(($site,$rfc931,$user,$when,$request,$status,$bytes,$from,$agent)=

		/^(\S+)\s*(\S+)\s*(\S+)\s*\[([^\]]+)]\s*\"([^\"]+)"\s*(\S+)\s*(\S+)\s*\"\s*([^\"]*)\s*\"\s*\"\s*([^\"]*)\s*\"\s*$/o)

		  { $lineerrors++; next; }



		$totallines++;



		# get all the time info

		($date,$month,$year,$hour,$min,$sec) = 

			 ($when =~ m|(..)/(...)/..(..):(..):(..):(..)|o);

		$month = $MONTHS{$month};



		$datestamp = "${year}${month}${date}";



		# EXCITE

		if ($agent =~ /ArchitextSpider/i) {

			$hits{excite}{$datestamp}++;

			$total{excite}++;

			}

		# ALTA VISTA

		if ($agent =~ /Scooter/i) {

			$hits{altavista}{$datestamp}++;

			$total{altavista}++;

			}

		# INFOSEEK

		if ($agent =~ /InfoSeek/i) {

			$hits{infoseek}{$datestamp}++;

			$total{infoseek}++;

			}

		# LYCOS

		if ($agent =~ /Lycos/i) {

			$hits{lycos}{$datestamp}++;

			$total{lycos}++

			}

		# INKTOMI

		if ($agent =~ /Slurp/i) {

			$hits{inktomi}{$datestamp}++;

			$total{inktomi}++;

			}

		} #end of while loop



	close(LOG);

	print STDERR "\nDone Reading $LOG - read $totallines lines\n\n";

	}



&ReadLog($log);



$excite = new Graph;

$altavista = new Graph;

$infoseek = new Graph;

$lycos = new Graph;

$inktomi = new Graph;



# Get the current time/date

($x,$MIN,$HOUR,$MDAY,$MONTH,$YEAR,$x,$x,$x) = localtime(time);

$YEAR--;

$time = timelocal(0,0,1,$MDAY,$MONTH,$YEAR,0,0,0);

while ($days > 0) {

	($x,$MIN,$HOUR,$MDAY,$MONTH,$YEAR,$x,$x,$x) = localtime($time);



	$MONTH++;

	$MONTH =~ s|^(\d)$|0$1|;

	$MDAY  =~ s|^(\d)$|0$1|;



	if ($MDAY == 1) { 

		$label = "$MONTH / $YEAR";

		}

	else {

		$label="";

		}

	$datestamp = $YEAR . $MONTH . $MDAY;

	$excite->data( $hits{excite}{$datestamp} || 0 , $label );

	$altavista->data( $hits{altavista}{$datestamp} || 0 , $label );

	$infoseek->data( $hits{infoseek}{$datestamp} || 0 , $label );

	$lycos->data( $hits{lycos}{$datestamp} || 0 , $label );

	$inktomi->data( $hits{inktomi}{$datestamp} || 0 , $label );



	$time += 60 * 60 * 24;

	$days--;

	}



# Excite graph

$excite->set_color("bar_color", 255, 204, 00);

$excite->color_list("bar_color");

$excite->bar_size("2");

$excite->bar_spacing("0");

$excite->bar_shadow_depth("0");

$excite->value_labels("0,25,50,75,100");

$excite->title("Excite Spider Visits");

$excite->subtitle("Agent: ArchitextSpider");

$excite->values_label("Hits");

$excite->keys_label("Date");

$excite->value_min("0");

$excite->output("excite.gif");



# Altavista graph

$altavista->set_color("bar_color", 0, 0, 255);

$altavista->color_list("bar_color");

$altavista->bar_size("2");

$altavista->bar_spacing("0");

$altavista->bar_shadow_depth("0");

$altavista->value_labels("0,25,50,75,100");

$altavista->title("AltaVista Spider Visits");

$altavista->subtitle("Agent: Scooter");

$altavista->values_label("Hits");

$altavista->keys_label("Date");

$altavista->value_min("0");

$altavista->output("altavista.gif");



# Infoseek graph

$infoseek->set_color("bar_color", 0, 0, 0);

$infoseek->color_list("bar_color");

$infoseek->bar_size("2");

$infoseek->bar_spacing("0");

$infoseek->bar_shadow_depth("0");

$infoseek->value_labels("0,25,50,75,100");

$infoseek->title("InfoSeek Spider Visits");

$infoseek->subtitle("Agent: InfoSeek Sidewinder");

$infoseek->values_label("Hits");

$infoseek->keys_label("Date");

$infoseek->value_min("0");

$infoseek->output("infoseek.gif");



# Lycos graph

$lycos->set_color("bar_color", 204, 0, 0);

$lycos->color_list("bar_color");

$lycos->bar_size("2");

$lycos->bar_spacing("0");

$lycos->bar_shadow_depth("0");

$lycos->value_labels("0,25,50,75,100");

$lycos->title("Lycos Spider Visits");

$lycos->subtitle("Agent: Lycos_Spider");

$lycos->values_label("Hits");

$lycos->keys_label("Date");

$lycos->value_min("0");

$lycos->output("lycos.gif");



# Inktomi graph

$inktomi->set_color("bar_color", 153, 255, 51);

$inktomi->color_list("bar_color");

$inktomi->bar_size("2");

$inktomi->bar_spacing("0");

$inktomi->bar_shadow_depth("0");

$inktomi->value_labels("0,25,50,75,100");

$inktomi->title("Inktomi Spider Visits");

$inktomi->subtitle("Agent: Slurp");

$inktomi->values_label("Hits");

$inktomi->keys_label("Date");

$inktomi->value_min("0");

$inktomi->output("inktomi.gif");



open(OUT,"> spiders.html");

print OUT <<END;

<HTML>

<HEAD><TITLE>Spider Report</TITLE></HEAD>

<BODY BGCOLOR="#dddddd">

<center>

<H1 align=center>Spider Report</H1>

<HR>

<i>(Note: Graph scales are not the same)</i>

<br>

<IMG SRC="excite.gif"><BR><BR>

<IMG SRC="altavista.gif"><BR><BR>

<IMG SRC="infoseek.gif"><BR><BR>

<IMG SRC="lycos.gif"><BR><BR>

<IMG SRC="inktomi.gif"><BR><BR>



<HR>

<a href="http://mkruse.netexpress.net/">http://mkruse.netexpress.net/</a>

</center>



</BODY>

</HTML>



END

close(OUT);



